// NetUNO.h -- Wedge's Net UNO common defs
//

#include <math.h>

UINT	Random(UINT max) { return MulDiv(rand(),max,RAND_MAX); };

typedef UINT CARD;

#define CSUIT(l)	((int) ((l)%4) )
#define CNUM(l)		(1+(int) ((l)/4) )

typedef struct _GAMESTATS
{
	BOOL		bDirFwds;
	CARD		cTopCard;
	UINT		nTurn;
	BOOL		bYourTurn;
} GAMESTATS;


class HAND
{
	protected:
		UINT	nCards;
		CARD	card[52];

	public:
		// =======================
		HAND(BOOL bDeck=FALSE) 
		{
			if (!bDeck) // init an empty hand;
			{
				nCards=0;
			}
			else // init a new deck;
			{
				nCards=52;
				for (UINT i=0; i<nCards; i++)
					card[i] =i;
			}
		}

		// =======================
		CARD TakeTopCard(void)
		{
			if (!nCards) return 255;
			nCards--;
			return card[nCards];
		}

		// =======================
		CARD TakeCard(UINT n)
		{
			if (n >= nCards) return 255;
			CARD retCard = card[n];
			nCards--;
			if (nCards)
				for (UINT i=n; i<(nCards); i++)
					card[i] = card[i+1];
			return retCard;
		}

		// =======================
		BOOL GiveCard(CARD c)
		{
			if (nCards > 51) return FALSE;
			card[nCards] = c;
			nCards++;
			return TRUE;
		}

		// =======================
		BOOL GiveCardBottom(CARD c)
		{
			if (nCards > 51) return FALSE;
			for (UINT i=nCards; i>0; i--)
				card[i] = card[i-1];
			card[0] = c;
			nCards++;
			return TRUE;
		}

		// =======================
		CARD PeekCard(UINT n) {if (n >= nCards) return 255; return card[n]; };
		CARD PeekTopCard(void) {if (!nCards) return 255; return card[nCards-1]; };
		UINT GetNumCards(void) {return nCards; };

		// =======================
		void Shuffle(UINT t=800)
		{
			if (!nCards) return;
			for (UINT a=0; a<t; a++)
			{
				for (UINT b=0; b<(nCards-1); b++)
				{
					if (Random(2)==1)
					{
						CARD cTemp = card[b];
						card[b] = card[b+1];
						card[b+1] = cTemp;
					}
				}
			}
			
		}

		// =======================
		void Order(void)
		{
			if (!nCards) return;
			for (UINT a=0; a<(nCards-1); a++)
			{
				for (UINT b=0; b<(nCards-1); b++)
				{
					if (card[b] > card[b+1])
					{
						CARD cTemp = card[b];
						card[b] = card[b+1];
						card[b+1] = cTemp;
					}
				}
			}
		}

};
